*
* Animal Kingdom
*
* (c) 1989, Unicorn Software
* (u) 2021, Antoine Vignau
*

         mx    %00
         rel
         lst   off

*------------------------

         use   PROT.X.S

GSOS     EQU   $E100A8

	use   4/ACE.Macs
	use   4/Ctl.Macs
	use   4/Dialog.Macs
	use   4/Desk.Macs
	use   4/Event.Macs
	use   4/Font.Macs
	use   4/Int.Macs
	use   4/Line.Macs
	use   4/List.Macs
	use   4/Locator.Macs
	use   4/Mem.Macs
	use   4/Menu.Macs
	use   4/Misc.Macs
	use   4/Print.Macs
	use   4/QD.Macs
	use   4/QDAux.Macs
	use   4/SANE.Macs
	use   4/Std.Macs
	use   4/Sound.Macs
	use   4/Text.Macs
	use   4/Util.Macs
	use   4/Window.Macs

*------------------------

L040000  ENT
L050012  ENT
         RTL

L040001  ENT
L050020  ENT
         PHK
         PLB
         SEP   #$30
         LDY   #$04
         LDA   ($E0),Y
         STA   L0401CA
         TAX
         INY
         LDA   ($E0),Y
         STA   L0401CB
         JSR   L040138
         STA   L0401CC
         STZ   L040032
         LDX   #$07
L04001E  STX   $EA
         JSR   L040033
         BCC   L040031
         LDX   $EA
         DEX
         BNE   L04001E
         LDA   L040032
         BNE   L040031
         LDA   #$33
L040031  RTL

L040032  DB    $00
L040033  JSR   L040228
         BCS   L0400AA
         LDA   #$00
         STA   $EB
         JSR   L040174
         LDX   L040186
         INX
         STX   $EC
         LDX   #$01
L040047  STX   $EB
         STX   L0401C4
         STX   L0401AE
         JSR   L04005C
         BCC   L04005B
         LDX   $EB
         INX
         CPX   $EC
         BCC   L040047
L04005B  RTS

L04005C  LDA   #$03
         JSR   L040174
         LDA   L040186
         AND   #$10
         BEQ   L0400AA
         LDA   L04019B
         CMP   #$01
         BNE   L0400AA
         JSR   L0400DC
         BCS   L0400AA
         LDA   L04019C
         CMP   #$C0
         BEQ   L0400AC
         CMP   #$00
         BNE   L0400AA
         LDA   #$06
         LDX   #L0401D0
         LDY   #>L0401D0
         JSR   L0401B5
         BCS   L0400A7
         LDA   #$07
         LDX   #L040266
         LDY   #>L040266
         JSR   L0401B5
         BCS   L0400A7
         LDA   #$05
         LDX   #L0401C8
         LDY   #>L0401C8
         JSR   L0401B5
         BCS   L0400A7
         LDA   #$05
         JSR   L040174
         BCC   L0400C8
L0400A7  STA   L040032
L0400AA  SEC
         RTS

L0400AC  LDA   #$05
         LDX   #L0401D4
         LDY   #>L0401D4
         JSR   L0401B5
         BCS   L0400A7
         JSR   L040111
         JSR   L0401A2
         LDA   #$06
         LDX   #L0401DB
         LDY   #>L0401DB
         JSR   L0401B5
         BCS   L0400A7
L0400C8  LDA   L04018C
         PHA
         LDA   L040189
         LDX   L04018A
         LDY   L04018B
         PLP
         SEP   #$30
         CLI
         BCS   L0400A7
         RTS

L0400DC  REP   #$20
         LDA   [$E2]
         STA   $F4
         STA   L0401AF
         LDY   #$00
         LDA   ($E0),Y
         SEC
         SBC   #$0005
         STA   $ED
         SEP   #$20
         INY
         INY
         LDA   ($E0),Y
         SBC   #$00
         STA   $EF
         LDX   #$02
         LDY   #$00
         JSR   L0401A2
         BCS   L04010D
         LDY   #$04
L040104  INY
         LDA   [$ED],Y
         BEQ   L04010F
         CMP   ($F4),Y
         BEQ   L040104
L04010D  SEC
         RTS

L04010F  CLC
         RTS

L040111  LDA   #$00
         STA   $F7
         LDX   L0401CA
         LDY   L0401CC
         BEQ   L040120
         JSR   L040138
L040120  STA   $F6
L040122  DEX
         BMI   L040133
         JSR   L040138
         ASL
         ADC   $F6
         STA   $F6
         BCC   L040122
         INC   $F7
         BCS   L040122
L040133  LDX   $F6
         LDY   $F7
         RTS

L040138  TXA
         LSR
         LSR
         LSR
         LSR
         TAY
         LDA   L040142,Y
         RTS

L040142  HEX   0C0B0A0908
L040147  SEI
         PHD
         REP   #$20
         LDAL  L01AFE9
         TCD
         SEP   #$20
         LDAL  L0401CC
         STA   $F8
         LDA   #$EC
         LDY   #$C0
         JSR   L0402A6
         PHB
         PHK
         PLB
         PHP
         STA   L040189
         STX   L04018A
         STY   L04018B
         PLA
         STA   L04018C
         PLB
         PLD
         CLC
         RTL

L040174  STA   L040185
         LDA   $EB
         STA   L040182
         LDA   #$00
         JSR   L0401DE
L040181  DB    $03
L040182  DB    $01
         DA    L040186
L040185  DB    $00
L040186  DB    $00
         DB    $00
         DB    $00
L040189  DB    $00
L04018A  DB    $00
L04018B  DB    $00
L04018C  DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
L04019B  DB    $00
L04019C  DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
         DB    $00
L0401A2  STX   L0401B1
         STY   L0401B2
         LDA   #$01
         JSR   L0401DE
         DB    $03
L0401AE  DB    $01
L0401AF  DB    $00
         DB    $20
L0401B1  DB    $00
L0401B2  DB    $00
         DB    $00
         DB    $00
L0401B5  STA   L0401C7
         STX   L0401C5
         STY   L0401C5+1
         LDA   #$04
         JSR   L0401DE
         DB    $03
L0401C4  DB    $01
L0401C5  DA    L0401C8
L0401C7  DB    $00
L0401C8  DB    $06
         DB    $00
L0401CA  DB    $00
L0401CB  DB    $00
L0401CC  DB    $00
         DB    $34
         DB    $00
         DB    $05
L0401D0  DB    $02
         DB    $00
         DB    $00
         DB    $05
L0401D4  DB    $04
         DB    $00
         DB    $82
         ADRL  L040147
L0401DB  DB    $04
         DB    $00
         DB    $00
L0401DE  STA   L040215
         REP   #$20
         PLA
         INC
         STA   L040216
         SEP   #$30
         JSL   L0401EF
         RTS

L0401EF  PHD
         PHB
         PHP
         REP   #$30
         TSC
         TSX
         SEP   #$20
         XBA
         DEC
         BEQ   L040207
         LDA   #$01
         XBA
         LDAL  $010100
         SEC
         SBC   #$10
         TCS
L040207  PEA   $0000
         PLD
         LDA   #$00
         PHA
         PLB
         PHX
         SEC
         XCE
L040212  JSR   $FFFF
L040215  DB    $00
L040216  DB    L040181
         DB    $01
         PHP
         CLC
         XCE
         PLP
         TAY
         ROR
         REP   #$10
         PLX
         TXS
         PLP
         PLB
         PLD
         ROL
         TYA
         RTL

         MX    %11
L040228  TXA
         LDX   #$00
         ORA   #$C0
         STX   $ED
         STA   $EE
         LDA   #$E1
         STA   $EF
         LDX   #$03
L040237  LDY   L04025E,X
         LDA   L040262,X
         CMP   [$ED],Y
         BNE   L04025C
         DEX
         BPL   L040237
         LDY   #$FF
         LDA   [$ED],Y
         BEQ   L04025C
         CMP   #$FF
         BEQ   L04025C
         ADC   $ED
         LDX   $EE
         ADC   #$03
         STA   L040212+1
         STX   L040212+2
         CLC
         RTS

L04025C  SEC
         RTS

L04025E  HEX   01030507
L040262  JSR   $0300
         DB    $00
L040266  DB    $00
         DB    $01
         STA   $14
         STY   $F8
         TXA
         ROR
         ROR
         AND   #$80
         STA   $16
         JSR   $007B
         BCS   L04029C
         LDA   #$30
         STA   $F6
L04027C  DEC   $F6
         BEQ   L04029F
         JSR   $0072
         BCS   L04027C
         LDA   $29
         ROR
         ROR
         ROR
         AND   #$40
         ORA   $2B
         CMP   $14
         BNE   L04029F
         LDA   $2A
         BNE   L04027C
         LDA   #$0C
         LDY   #$0A
         BNE   L0402A6
L04029C  LDA   #$32
         HEX   2C
L04029F  LDA   #$31
         HEX   2C
L0402A2  LDA   #$30
         SEC
         RTS

L0402A6  STA   $F0
         STY   $F1
         LDA   #$00
         STA   $F4
         STA   $F5
L0402B0  LDX   #$00
         LDY   #$F8
         STY   $F7
L0402B6  INX
         BNE   L0402BD
         INC   $F7
         BEQ   L0402A2
L0402BD  LDA   ($F0)
         BPL   L0402BD
L0402C1  CMP   #$D5
         BNE   L0402B6
L0402C5  LDA   ($F0)
         BPL   L0402C5
         CMP   #$AA
         BNE   L0402C1
L0402CD  LDA   ($F0)
         BPL   L0402CD
         CMP   #$96
         BNE   L0402C1
         CLC
         TXA
         ADC   #$05
         TAX
         LDA   $F7
         ADC   #$08
         TAY
         CLC
         TXA
         ADC   $F4
         STA   $F4
         TYA
         ADC   $F5
         STA   $F5
         DEC   $F8
         BNE   L0402B0
         LDA   #$00
         LDX   $F4
         LDY   $F5
         CLC
         RTS

